<template>
	<div v-if="totalPages > 1" class="paginator">
		<div class="paginator__spacer">
			<button v-if="prevPageAvailable" @click="setPage(currentPage - 1)" class="button">&cularr;</button>
		</div>

		<ul class="paginator__pages">
			<li v-if="currentPage > limiter + 1">
				<button @click="setPage(1)" class="button">1</button>
			</li>

			<li v-if="currentPage > limiter + 2" class="paginator__dots">...</li>

			<template v-for="n in totalPages">
				<li :key="n" v-if="n >= currentPage - limiter && n <= currentPage + limiter">
					<button
						@click="setPage(n)"
						:disabled="n === currentPage"
						class="button"
					>{{ n }}</button>
				</li>
			</template>

			<li v-if="currentPage + limiter + 1 < totalPages" class="paginator__dots">...</li>

			<li v-if="currentPage + limiter < totalPages">
				<button @click="setPage(totalPages)" class="button">{{ totalPages }}</button>
			</li>
		</ul>

		<div class="paginator__spacer">
			<button v-if="nextPageAvailable" @click="setPage(currentPage + 1)" class="button">&curarr;</button>
		</div>
	</div>
</template>

<script>
export default {
	name: "Paginator",
	data: () => ({
	}),
	props: {
		limiter: Number,
		totalPages: Number,
		currentPage: Number
	},
	methods: {
		setPage(page) {
			this.$emit("clicked", page);
		}
	},
	computed: {
		prevPageAvailable() {
			return this.currentPage > 1;
		},
		nextPageAvailable() {
			return this.currentPage < this.totalPages;
		}
	}
}
</script>

<style scoped>

</style>